// PDMapCreatorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PDMapCreator.h"
#include "PDMapCreatorDlg.h"
#include "greta\regexpr2.h"

using namespace regex;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CPDMapCreatorDlg dialog
CPDMapCreatorDlg::CPDMapCreatorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPDMapCreatorDlg::IDD, pParent)
	, m_sourceFolder(_T(""))
	, m_targetFile(_T(""))
	, m_sourceType(GEOKUK)
	, m_fileOk(FALSE)
	, m_folderOk(FALSE)
	, m_formatAuto(TRUE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hIconOK = (HICON)::LoadImage(AfxGetResourceHandle(), MAKEINTRESOURCE(IDI_ICON_OK), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
	m_hIconInvalid = (HICON)::LoadImage(AfxGetResourceHandle(), MAKEINTRESOURCE(IDI_ICON_INVALID), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);

	m_sourceFolder = theApp.GetProfileString(_T("Options"), _T("Folder"), _T(""));
	m_targetFile   = theApp.GetProfileString(_T("Options"), _T("File"), _T(""));
}

void CPDMapCreatorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, m_sourceFolder);
	DDX_Text(pDX, IDC_EDIT2, m_targetFile);	
	DDX_Radio(pDX, IDC_RADIO_GEOKUK, (int&)m_sourceType);
	DDX_Check(pDX, IDC_CHECK_AUTO, m_formatAuto);
	DDX_Control(pDX, IDC_FILE_OK, m_ctrlFileOkIcon);
	DDX_Control(pDX, IDC_FOLDER_OK, m_ctrlFolderOkIcon);
	DDX_Control(pDX, IDC_PROGRESS1, m_progress);
	DDX_Control(pDX, IDC_BTN_CONVERT, m_ctrlConvert);
}

BEGIN_MESSAGE_MAP(CPDMapCreatorDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BTN_SRC_FOLDER, &CPDMapCreatorDlg::OnBnClickedBtnSrcFolder)
	ON_BN_CLICKED(IDC_BTN_DST_FILE,   &CPDMapCreatorDlg::OnBnClickedBtnDstFile)
	ON_BN_CLICKED(IDC_BTN_CONVERT,    &CPDMapCreatorDlg::OnBnClickedBtnConvert)
	ON_BN_CLICKED(IDC_BTN_CREATE, &CPDMapCreatorDlg::OnBnClickedBtnCreate)
	ON_BN_CLICKED(IDC_BTN_GEOKUK, &CPDMapCreatorDlg::OnBnClickedBtnGeokuk)
END_MESSAGE_MAP()


// CPDMapCreatorDlg message handlers

BOOL CPDMapCreatorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_ctrlFileOkIcon.SetIcon(m_hIconInvalid);
	m_ctrlFolderOkIcon.SetIcon(m_hIconInvalid);

	GetDlgItem(IDC_BTN_CONVERT)->EnableWindow(FALSE);
	CheckParams();
	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}


// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPDMapCreatorDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPDMapCreatorDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CPDMapCreatorDlg::OnBnClickedBtnSrcFolder()
{
	UpdateData();

	BROWSEINFO bi = { 0 };
    LPITEMIDLIST pidl = SHBrowseForFolder(&bi);
    if (pidl != 0)
    {
        // get the name of the folder
        TCHAR path[MAX_PATH];
		if (SHGetPathFromIDList(pidl, path)) {
			m_sourceFolder = path;
			CheckParams(CP_SRC);
		}

        // free memory used
        IMalloc * imalloc = 0;
        if (SUCCEEDED(SHGetMalloc(&imalloc))) {
            imalloc->Free(pidl);
            imalloc->Release();
        }
    }

	UpdateData(FALSE);
}

void CPDMapCreatorDlg::OnBnClickedBtnGeokuk()
{
	HKEY hKey;
	DWORD dwType, dwSize;
	char buf[256];

	// Cteni hodnot z klice
	LSTATUS res = RegOpenKeyEx(HKEY_CURRENT_USER, _T("Software\\JavaSoft\\Prefs\\geokuk\\current\\umisteni/Souboru"), 0, KEY_READ, &hKey);
	if (res == ERROR_SUCCESS) {
		dwSize=sizeof(buf);
		res = RegQueryValueEx(hKey, _T("kachle/Cache/Dir"), NULL, &dwType, (LPBYTE)buf, &dwSize);
		if (res == ERROR_SUCCESS) {
			m_sourceFolder.Format(_T("%s"), buf);
			m_sourceFolder.Replace(_T("//"), _T("\\"));
			m_sourceFolder.Replace(_T("/"), _T(""));
			AnalyzeFolder(m_sourceFolder);
		};
		RegCloseKey(hKey);
	} 

	UpdateData(FALSE);
}

void CPDMapCreatorDlg::OnBnClickedBtnDstFile()
{
	UpdateData();

	CFileDialog FileDlg(TRUE, _T(".pdmap"), NULL, 0, 
		_T("Mapa PocketDrake (*.pdmap)|*.pdmap|Vechny soubory (*.*)|*.*||"));

	if( FileDlg.DoModal() == IDOK ) 
		m_targetFile = FileDlg.GetPathName();
	
	CheckParams(CP_DST);
	UpdateData(FALSE);
}

void CPDMapCreatorDlg::OnBnClickedBtnCreate()
{
	if (m_mapFile.Open(m_targetFile) == SQLITE_OK) {
		m_mapFile.Execute(_T("PRAGMA encoding = \"UTF-8\"")); 
		m_mapFile.Execute(_T("CREATE TABLE IF NOT EXISTS info(minzoom,maxzoom)"));
		m_mapFile.Execute(_T("CREATE TABLE IF NOT EXISTS tiles(x int, y int, z int, s int, image blob, PRIMARY KEY (x,y,z,s))"));
		CheckParams(CP_DST);
	}
}

void CPDMapCreatorDlg::OnBnClickedBtnConvert()
{
	if (m_convertor.Running()) {
		m_convertor.Stop();
		m_ctrlConvert.EnableWindow(FALSE);
	} else {
		m_ctrlConvert.SetWindowTextW(_T("Zastavit"));
		EnableControls(FALSE);

		m_totalCount = m_processedCount = 0;
		m_progress.SetPos(0);

		m_convertor.m_sourceType   = m_sourceType;
		m_convertor.m_sourceFolder = m_sourceFolder;
		m_convertor.m_mapFile = &m_mapFile;

		m_convertor.Start();
	}
}

void CPDMapCreatorDlg::OnCancel()
{
	m_convertor.Close();
	m_mapFile.Close();
	SaveOptions();

	CDialog::OnCancel();
}

void CPDMapCreatorDlg::SaveOptions()
{
	theApp.WriteProfileString(_T("Options"), _T("Folder"), m_sourceFolder );
	theApp.WriteProfileString(_T("Options"), _T("File"), m_targetFile);
}

// kontrola zadanych parametru
void CPDMapCreatorDlg::CheckParams(CheckParamMode mode)
{
	if (mode & CP_SRC) {
		CFileStatus status;
		if (CFile::GetStatus(m_sourceFolder, status) && AnalyzeFolder(m_sourceFolder)) {
			m_ctrlFolderOkIcon.SetIcon(m_hIconOK);
			m_folderOk = TRUE;
		} else {
			m_ctrlFolderOkIcon.SetIcon(m_hIconInvalid);
			m_folderOk = FALSE;
		}
		m_ctrlFolderOkIcon.Invalidate();
	}
	
	if (mode & CP_DST) {
		m_mapFile.Close();
		m_mapFile.Invalidate();

		// test existence souboru
		CFileStatus status;
		if (CFile::GetStatus(m_targetFile, status)) {
			m_mapFile.Open(m_targetFile);

			try {
				SQLStatement qry = m_mapFile.Prepare(_T("SELECT * FROM `tiles` LIMIT 1"));
				qry.Step();
			} catch (CDbProxy::Error e) {
				AfxMessageBox(e.getErrorMessage());
				m_mapFile.Invalidate();
			}
		}
		if (m_mapFile.isValid()) {
			m_ctrlFileOkIcon.SetIcon(m_hIconOK);
			m_fileOk = TRUE;
		} else {
			m_ctrlFileOkIcon.SetIcon(m_hIconInvalid);
			m_fileOk = FALSE;
		}
		m_ctrlFileOkIcon.Invalidate();
	}

	if (m_fileOk && m_folderOk) 
		GetDlgItem(IDC_BTN_CONVERT)->EnableWindow();
	else
		GetDlgItem(IDC_BTN_CONVERT)->EnableWindow(FALSE);

	SaveOptions();
}

// test obsahu slozky, zda obsahuje vhodne kachle
BOOL CPDMapCreatorDlg::AnalyzeFolder(CString aFolder)
{
//  Spocitam dlazdice v adresari
	WIN32_FIND_DATA FileData;   // Data structure describes the file found
	HANDLE hSearch;             // Search handle returned by FindFirstFile
	CString DirMask = aFolder + _T("\\*.*");

	hSearch = FindFirstFile (DirMask, &FileData);
	if (hSearch != INVALID_HANDLE_VALUE) {
		do {
			if (FileData.dwFileAttributes == FILE_ATTRIBUTE_DIRECTORY) {
				if (wcscmp(FileData.cFileName, _T(".")) != 0 && wcscmp(FileData.cFileName, _T("..")) != 0) {
					FindClose(hSearch);
					return AnalyzeFolder(aFolder + _T("\\") + FileData.cFileName);
				}
			} else {
				FindClose(hSearch);
				CString f = aFolder + _T("\\") + FileData.cFileName;
				f.Replace(m_sourceFolder, _T(""));

				std::wstring file = f.GetBuffer();

			    match_results results;
			    rpattern pat1(_T("^\\\\[0-9a-f]{2}\\\\[0-9a-f]{2}\\\\[0-9a-f]{2}\\\\[0-9a-f]{2}\\\\.*\\.kachle"));
			    match_results::backref_type br1 = pat1.match(file, results);
				if(br1.matched) {
					if (m_formatAuto) m_sourceType = GEOKUK;
					return TRUE;
				}
			    rpattern pat2(_T("^\\\\[0-9]{2}\\\\[0-9]{2,}\\\\[0-9]{2,}\\.(png|jpg)"));
			    match_results::backref_type br2 = pat2.match(file, results);
				if(br2.matched) {
					if (m_formatAuto) m_sourceType = OSMTILE;
					return TRUE;
				}
				return FALSE;
			}				
		} 
		while (FindNextFile (hSearch, &FileData));
	} 
	FindClose(hSearch);

	return TRUE;
}

// povoli nebo zakaze ovladaci prvky
void CPDMapCreatorDlg::EnableControls(BOOL enable)
{
	GetDlgItem(IDC_EDIT1)->EnableWindow(enable);
	GetDlgItem(IDC_BTN_SRC_FOLDER)->EnableWindow(enable);
	GetDlgItem(IDC_BTN_GEOKUK)->EnableWindow(enable);
	GetDlgItem(IDC_EDIT2)->EnableWindow(enable);
	GetDlgItem(IDC_BTN_DST_FILE)->EnableWindow(enable);
	GetDlgItem(IDC_BTN_CREATE)->EnableWindow(enable);
	GetDlgItem(IDC_RADIO_GEOKUK)->EnableWindow(enable);
	GetDlgItem(IDC_RADIO_OSM)->EnableWindow(enable);
	GetDlgItem(IDC_CHECK_AUTO)->EnableWindow(enable);
}

// zpracovani zprav z vlakna prevadece 
void CPDMapCreatorDlg::OnThreadMessage(WPARAM wParam, LPARAM lParam)
{
	switch (wParam) {
		case TM_COUNT: {
			m_totalCount = lParam;
			CString count;
			count.Format(_T("%d"), m_totalCount);
			((CStatic*)GetDlgItem(IDC_STATIC_COUNT))->SetWindowText(count);
			break;
		}
		case TM_CONVERT: {
			if (m_processedCount == 0) 
				m_progress.SetRange(0, m_totalCount);
			
			m_processedCount = lParam;
			CString count;
			count.Format(_T("%d z %d"), m_totalCount-m_processedCount, m_totalCount);
			((CStatic*)GetDlgItem(IDC_STATIC_COUNT))->SetWindowText(count);
			m_progress.SetPos(m_processedCount);
			break;
		}
		case TM_FINISHED: {
			m_ctrlConvert.SetWindowText(_T("Pevst"));
			m_ctrlConvert.EnableWindow();
			EnableControls();
			break;
		}
	}
}

